apiVersion: opentelemetry.io/v1alpha1
kind: OpenTelemetryCollector
metadata:
  name: otel-collector
  namespace: observability
  labels:
    component: otel-collector
spec:
  config: |
    # OTel receiver - GitLab Runner writing into
    # https://opentelemetry.io/docs/collector/configuration/#receivers 
    receivers:
      jaeger:
        protocols:
          grpc:
      otlp:
        protocols:
          grpc:
          http:
      zipkin:
    # OTel exporter writing to Jaeger+Clickhouse backend
    # kubectl get svc -n observability
    # https://opentelemetry.io/docs/collector/configuration/#exporters 
    exporters:
      jaeger:
        endpoint: "jaeger-clickhouse-collector-headless.observability:14250"
        tls:
          insecure: true
      logging:
        loglevel: debug

    processors:
      batch:

    extensions:
      health_check:
      pprof:
      zpages:

    # https://opentelemetry.io/docs/collector/configuration/#service
    service:
      extensions: [health_check, pprof, zpages]
      telemetry:
        logs:
          level: debug
          initial_fields:
            service: otel-gitlab
      pipelines:
        traces:
          receivers: [jaeger,otlp,zipkin]
          processors: [batch]
          exporters: [jaeger,logging]
# TODO: Service does not work yet
---
apiVersion: v1
kind: Service
metadata:
  name: otel-collector
  namespace: observability
  labels:
    app: otel
spec:
  type: LoadBalancer
  selector:
#    app.kubernetes.io/component: opentelemetry-collector
    name: otel-collector

  # Expose ports as load balancer
  ports:
  - name: grpc-otlp
    port: 4317
    protocol: TCP
    targetPort: 4317
  - name: http-otlp
    port: 4318
    protocol: TCP
    targetPort: 4318
